//
//  productAPI.swift
//  shop2
//
//  Created by Jehu Ombrog on 8/22/24.
//

import Foundation
class productController{
    
    func fetchProductDetails() async throws -> [productDetails] {
        let urlString = "https://fakestoreapi.com/products"
        guard let  url = URL(string:urlString) else { return [] } // to check that url must have value
        
        do{
            let (data , _) = try await URLSession.shared.data(from: url)
            let productList = try JSONDecoder().decode([productDetails].self, from: data)
            return productList
        }catch{
            print("DEBUG: Error \(error.localizedDescription)")
            return []
        }
    }
    
    func fetchOneProductDetails(id : String) async throws -> productDetails? {
        let urlString = "https://fakestoreapi.com/products/\(id)"
        guard let  url = URL(string:urlString) else { return  nil } // to check that url must have value
        
        do{
            let (data , _) = try await URLSession.shared.data(from: url)
            let productList = try JSONDecoder().decode(productDetails.self, from: data)
            return productList
        }catch{
            print("DEBUG: Error \(error.localizedDescription)")
            return nil
        }
    }
}
