//
//  SecondViewController.swift
//  shop2
//
//  Created by Jehu Ombrog on 8/22/24.
//

import UIKit

class SecondViewController: UIViewController {

    @IBOutlet weak var productName : UILabel!
    @IBOutlet weak var productPrice : UILabel!
    @IBOutlet weak var productImage : UIImageView!
  
   
    var productDetail : productDetails?
    var id = ""

    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        Task {
            do {
                try await fetchProduct()
            } catch {
                print("Failed to fetch products: \(error)")
            }
        }
   
    }
    
    func fetchProduct() async throws {
            do {
                self.productDetail = try await productController().fetchOneProductDetails(id: id)
                productName.text = productDetail?.title
                productPrice.text = String(format: "$%.2f", productDetail!.price)
                
                if let imageUrl = URL(string: productDetail!.image) {
                    ViewController().loadImage(from: imageUrl) { image in
                        DispatchQueue.main.async {
                            self.productImage.image = image
                            
                        }
                    }
                }
                
              

            } catch {
                print("Error fetching products: \(error)")
            }
        }
        
    
    


}
