//
//  ViewController.swift
//  shop2
//
//  Created by Jehu Ombrog on 8/21/24.
//

import UIKit

class ViewController: UIViewController, UITableViewDelegate, UITableViewDataSource {
    
    @IBOutlet var tableView : UITableView!
    private let productService = productController()
    var productList = [productDetails]()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        print("Table view:")

        
        tableView.delegate = self
        tableView.dataSource = self
        
        Task {
            do {
                try await fetchProducts()
                print("aye")
            } catch {
                print("Failed to fetch products: \(error)")
            }
        }

    }
    
    func fetchProducts() async throws {
        do {
            print("hey")
            self.productList = try await productService.fetchProductDetails()
            navigationItem.title = "Products"
    
            tableView.rowHeight = 120
            print("yo")
            tableView.reloadData()
        } catch {
            print("Error fetching products: \(error)")
        }
    }
    
    func loadImage(from url: URL, completion: @escaping (UIImage?) -> Void) {
        let task = URLSession.shared.dataTask(with: url) { data, response, error in
            if let error = error {
                print("Error fetching image: \(error)")
                completion(nil)
                return
            }
            guard let data = data, let image = UIImage(data: data) else {
                completion(nil)
                
                return
            }
            completion(image)
        }
        task.resume()
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return productList.count
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if let vc = storyboard?.instantiateViewController(withIdentifier: "third") as? SecondViewController{
            let product = productList[indexPath.row]
            vc.id = String(product.id)

            
            self .navigationController?.pushViewController(vc, animated: true)
        }
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "CustomTableViewCell", for: indexPath) as! CustomTableViewCell
        let product = productList[indexPath.row]
        
        if let imageUrl = URL(string: product.image) {
            loadImage(from: imageUrl) { image in
                DispatchQueue.main.async {
                    cell.producImage.image = image
                }
            }
        }
        
        cell.productName.text = product.title
        cell.productPrice.text = String(format: "$%.2f", product.price)
      
        
        return cell
    }
 
    
}

extension UIImageView{
    func load(url: URL) {
        DispatchQueue.global().async { [weak self] in
            if let data = try? Data(contentsOf: url){
                if let image = UIImage(data: data) {
                    DispatchQueue.main.async {
                        self?.image = image
                    }
                }
            }
        }
    }
}
